{
Fiche principale de IAide 1.5
Adrien Montfaucon - Vector
}
unit IAideMain;

interface

uses
  Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, FileCtrl, INIFiles, CheckLst, ExtCtrls,
  ComCtrls, ShellAPI;

type

  {Dfinitions des Types}

  IBool=0..1;

  {Forme principale}

  TIAMain = class(TForm)
    menu: TMainMenu;
    Fichier1: TMenuItem;
    Quitter1: TMenuItem;
    N1: TMenuItem;
    Dossierdaide1: TMenuItem;
    AFTopic: TCheckListBox;
    manual: TGroupBox;
    N2: TMenuItem;
    Aide1: TMenuItem;
    pmenu: TPopupMenu;
    outslectionner1: TMenuItem;
    outslectionner2: TMenuItem;
    Inverserlaslection1: TMenuItem;

    {Mthodes d'venements}

    procedure Quitter1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Dossierdaide1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Aide1Click(Sender: TObject);
    procedure AFTopicMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure outslectionner1Click(Sender: TObject);
    procedure outslectionner2Click(Sender: TObject);
    procedure Inverserlaslection1Click(Sender: TObject);

    {Mthodes de programme}

    procedure IniIAide;
    procedure IniPath;
    procedure Check(Checked:Boolean);
    procedure InverseCheck;
    procedure OpenFile(Item:IBool);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  IAMain: TIAMain;
  INIFile:TINIFile;
  AFTopicPath:TStringList; //Nom des fichiers, affichs dans AFTopic
  OHIData:array[0..1] of TStringList; //Contenu des fichiers OHI
  OHIHelpPath:array[0..1] of String; //Nom des fichiers OHI

const Options='Options'; //Dfini le nom de la section dans le INI
      ININame:array[0..1] of String=('HelpPath','ExtraHelpPath'); //Dfini les noms des cls dans le INI
      OHIFilter:array[0..1] of String=('d*.ohi','d*x*.ohi'); //Filtres pour la recherche de fichiers
      LIndex=Length('Index ');

implementation

{$R *.dfm}

procedure DeleteSpaceFile(var S:String);  //Enlve les espaces dans un nom de fichier
begin
while Pos(' ',S)<>0 do
  Delete(S,Pos(' ',S),1);
end;

procedure TIAMain.Quitter1Click(Sender: TObject); //Quitte
begin
Close;
end;

procedure TIAMain.FormCreate(Sender: TObject);
begin
AFTopicPath:=TStringList.Create;
AFTopic.MultiSelect:=True;
INIFile:=TINIFile.Create(ExtractFilePath(Application.EXEName)+'\IAideData.iad');  //Initialise le INI
if not INIFile.SectionExists(Options) then IniPath //Cre les sections
else IniIAide;
end;

procedure TIAMain.Dossierdaide1Click(Sender: TObject);
begin
IniPath; //Initialise les varibales de nom de fichiers
end;

procedure TIAMain.IniIAide;
var I:IBool;
begin
AFTopic.Clear;      //Initialise les listes
AFTopicPath.Clear;
for I:=0 to 1 do
  begin
  OHIHelpPath[I]:=INIFile.ReadString(Options,ININame[I],''); //Recherche les noms de fichier
  OpenFile(I); //Ouvre et affiche le contenu du fichier OHI
  end;
end;

procedure TIAMain.FormClose(Sender: TObject; var Action: TCloseAction);
var I,J,F,Attrs,PosBegin,PosEnd:Word;
    CurrentOHI,CurrentTopic,HelpFile:string;
    Search:TSearchRec;
    Find:Integer;
begin
for F:=0 to 1 do  //Sauvegarde les modifications
  begin
  for I:=0 to OHIData[F].Count-1 do
    begin
    CurrentOHI:=OHIData[F].Strings[I];
    for J:=0 to AFTopic.Items.Count-1 do
      begin
      CurrentTopic:=AFTopic.Items.Strings[J];
      HelpFile:=LowerCase(Copy(CurrentOHI,Pos('=',CurrentOHI)+1,Length(CurrentOHI)));
      DeleteSpaceFile(HelpFile);
      if AFTopicPath[J]=HelpFile then
        if (AFTopic.Checked[J]) and (Pos(';:',CurrentOHI)=1) then
          begin
          Delete(CurrentOHI,1,1);
          OHIData[F].Strings[I]:=CurrentOHI;
          end
        else if (not AFTopic.Checked[J]) and (Pos(';',CurrentOHI)<>1) then
          begin
          Insert(';',CurrentOHI,1);
          OHIData[F].Strings[I]:=CurrentOHI;
          end;
      end;
    end;
  Attrs:=FileGetAttr(OHIHelpPath[F]); //Rcupre les attributs (les OHI sont en lecture seule)
  if Attrs and faReadOnly <> 0 then
    FileSetAttr(OHIHelpPath[F], Attrs and not faReadOnly);
  DeleteFile(OHIHelpPath[F]);
  OHIData[F].SaveToFile(OHIHelpPath[F]);
  OHIData[F].Free; //Libre les ressources
  end;
Find:=FindFirst(ExtractFilePath(OHIHelpPath[0])+'*.gid',faAnyFile,Search); //Supprime les fichiers index (.gid)
while Find=0 do
  begin
  DeleteFile(ExtractFilePath(OHIHelpPath[0])+Search.Name);
  Find:=FindNext(Search);
  end;
FindClose(Search);
AFTopicPath.Free; //Libre les ressources
end;

procedure TIAMain.IniPath;
var Selected,Valid,BAbort:Boolean;
    Path:String;
    Search:TSearchRec;
    I:IBool;
begin
Path:=ExtractFilePath(INIFile.ReadString(Options,ININame[0],''));
BAbort:=False;
Valid:=True;
  repeat //Affiche la slection de dossier
  Selected:=SelectDirectory('Choisissez le dossier d''aide Delphi (Borland\DelphiX\Help) :','',Path);
  if not Selected then BAbort:=(MessageDlg('Vous devez slectionner un rpertoire. Voulez-vous recommencer ?',mtError,[mbYes,mbNo],0)=mrNo);
  until (Selected) or (BAbort);
if BAbort then
  begin
  AFTopic.Enabled:=False;
  Exit;
  end;
if FindFirst(Path+'\'+OHIFilter[0],faAnyFile,Search)=0 then
  begin
  if Pos('x',Lowercase(Search.Name))<>0 then FindNext(Search);
  OHIHelpPath[0]:=Path+'\'+Search.Name;
  end;
FindClose(Search);
if FindFirst(Path+'\'+OHIFilter[1],faAnyFile,Search)=0 then OHIHelpPath[1]:=Path+'\'+Search.Name;
FindClose(Search);
for I:=0 to 1 do
  INIFile.WriteString(Options,ININame[I],OHIHelpPath[I]);
IniIaide; //Initialise le programme
end;

procedure TIAMain.Aide1Click(Sender: TObject);
begin
ShellExecute(Handle,'Open',PChar(Application.HelpFile),nil,nil,SW_SHOWDEFAULT); //Ouvre l'aide
end;

procedure TIAMain.AFTopicMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer); //Popup
begin
if Button=mbRight then PMenu.Popup(AFTopic.ClientToScreen(Point(X,Y)).X,AFTopic.ClientToScreen(Point(X,Y)).Y);
end;

procedure TIAMain.Check(Checked: Boolean); //Coche les items slectionns
var I:Word;
begin
for I:=0 to AFTopic.Items.Count-1 do
  if AFTopic.Selected[I] then AFTopic.Checked[I]:=Checked;
end;

procedure TIAMain.outslectionner1Click(Sender: TObject);
begin
Check(True);
end;

procedure TIAMain.outslectionner2Click(Sender: TObject);
begin
Check(False);
end;

procedure TIAMain.OpenFile(Item:IBool); //Ouvre et analyse les fichiers OHI
var I,Cible:Word;
    Source,NewTopic,HelpFile:String;
begin
OHIData[Item]:=TStringList.Create;
OHIData[Item].LoadFromFile(OHIHelpPath[Item]); //Charge le fichier
for I:=0 to OHIData[Item].Count-1 do //Analyse le fichier
  begin
  Source:=OHIData[Item].Strings[I];
  if Pos(':',Source)=1 then
    begin
    NewTopic:=Copy(Source,2+LIndex,Pos('=',Source)-LIndex-2);
    HelpFile:=Copy(Source,Pos('=',Source)+1,Length(Source));
    DeleteSpaceFile(HelpFile);
    Cible:=AFTopic.Items.Add(NewTopic+' ('+HelpFile+')');
    AFTopicPath.Add(HelpFile);
    AFTopic.Checked[Cible]:=True;
    end
  else if Pos(';:',Source)=1 then
    begin
    NewTopic:=Copy(Source,3+LIndex,Pos('=',Source)-LIndex-3);
    HelpFile:=Copy(Source,Pos('=',Source)+1,Length(Source));
    DeleteSpaceFile(HelpFile);
    Cible:=AFTopic.Items.Add(NewTopic+' ('+HelpFile+')');
    AFTopicPath.Add(HelpFile);
    AFTopic.Checked[Cible]:=False;
    end;
  end;
end;

procedure TIAMain.Inverserlaslection1Click(Sender: TObject);
begin
InverseCheck; 
end;

procedure TIAMain.InverseCheck; //Inverse l'tat
var I:Word;
begin
for I:=0 to AFTopic.Count-1 do
  AFTopic.Checked[I]:=not AFTopic.Checked[I];
end;

end.
